module.exports = (function() {
  "use strict";

  var path = require("path");
  var fs = require("fs");
  var http = require("http");

  var downloadFile = function(url, target, cb) {
    var file = fs.createWriteStream(target);
    http.get(url, function(response) {
      response.pipe(file);
      file.on("finish", function() {
        file.close(cb);
      });
    })
    .on("error", function(err) {
      fs.unlink(target);
      cb(err);
    });
  };

  return downloadFile;
}())