module.exports = (function() {
  "use strict";
  var output = require("./output");

  var readInput = function(type, cb) {
    if (typeof type === "function") {
      cb = type;
      type = "json";      
    }
    if (typeof cb !== "function") {
      throw new Error("input.read - callback required");
    }
  
    // Set stdin encoding so we receive strings.
    process.stdin.setEncoding('utf8');

    var inputData = "";
    process.stdin.on('data', function (chunk) {
      inputData += chunk;
    });

    process.stdin.on('end', function () {      
      if (type === "json") {
        // Attempt to parse as json
        try {
          inputData = JSON.parse(inputData);
        } catch (e) {
          return cb(new Error("failed to parse " + inputData + " : " + e.message));
        }
      }

      cb(null,inputData);
    });

    output.debug("reading input");
    process.stdin.resume();
  };

  return {
    read: readInput
  };
}());