module.exports = (function() {
  "use strict";

  var commandLine = require("./command-line");
  var authKey = commandLine.authKey;
  var connectionWhitelist = [ "::ffff:127.0.0.1" ];

  var ensureAuthenticated = function(req, res, next) {
    if (authKey) {
      var requestKey = req.headers["authorization"];
      if (requestKey !== "Bearer " + authKey) {
        res.status(401);
        res.send("unauthorised");
      } else {
        next();
      }
    } else {
      next();
    }
  };  

  var authoriseConnection = function(sock) {
    // Only allow connections from localhost.
    if (connectionWhitelist.indexOf(sock.remoteAddress) === -1) {
      sock.destroy();
    } 
  }

  return {
    ensureAuthenticated: ensureAuthenticated,
    authoriseConnection: authoriseConnection
  }
}());